!
! calculate relative coordinates projecting one atom into replica cell
! Input
!  sdx,sdy,sdz : components of r-r0 vector
!  ix,iy,iz    : indicate which cell the atom is projected into
!                e.g. primitive cell if =0
!                     adjoining cell if =+1
! Output
!  sdx,sdy,sdz : components of r-r0
!
      subroutine calc_replica(sdx,sdy,sdz,rad,ix,iy,iz,istat)
      use constants
      use variables, only : hmat
      use debug_variables
      double precision :: sdx,sdy,sdz,rad
      double precision :: sdxi,sdyi,sdzi
      integer :: istat,ix,iy,iz

      if (ix/=0) then
         sdx=sdx+hmat(1,1)*dble(ix)
         sdy=sdy+hmat(2,1)*dble(ix)
         sdz=sdz+hmat(3,1)*dble(ix)
      endif
      if (iy/=0) then
         sdx=sdx+hmat(1,2)*dble(iy)
         sdy=sdy+hmat(2,2)*dble(iy)
         sdz=sdz+hmat(3,2)*dble(iy)
      endif
      if (iz/=0) then
         sdx=sdx+hmat(1,3)*dble(iz)
         sdy=sdy+hmat(2,3)*dble(iz)
         sdz=sdz+hmat(3,3)*dble(iz)
      endif
      istat=0
      if ((abs(sdx)<rad).and.(abs(sdy)<rad).and.(abs(sdz)<rad)) then
         if ((abs(sdx)>1.0d-15).or.(abs(sdy)>1.0d-15).or.(abs(sdz)>1.0d-15)) then
            istat=1
         endif
      endif
      end
