      subroutine calcelastic
      use variables
      use constants
      double precision :: strmat_store(3,3),hmat_store(3,3)
      double precision,allocatable :: rx_store(:),ry_store(:),rz_store(:)
      double precision :: inf_str

      strmat_store=strmat_set   ! Strain matrix save
                                ! (should be restored before return)

      allocate (rx_store(n),ry_store(n),rz_store(n))
      hmat_store=hmat           ! Cell matrix save
      rx_store=rx; ry_store=ry; rz_store=rz ! Atom position save

!      inf_str=1.0d-3            ! Infinitesimal strain
      inf_str=econstd
      
      elasc=0.0d0
!!!  C_11,C_12,C_13
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(1,1)=inf_str
      call strain
      call potential
      call calcstresstensor
      s1=sgmmat(1,1); s3=sgmmat(2,2); s5=sgmmat(3,3)
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(1,1)=-inf_str
      call strain
      call potential
      call calcstresstensor
      s2=sgmmat(1,1); s4=sgmmat(2,2); s6=sgmmat(3,3)
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;

!      c11 = (s1 - s2)/(inf_str * 2.0d0)
!      c12 = (s3 - s4)/(inf_str * 2.0d0)
!      c13 = (s5 - s6)/(inf_str * 2.0d0)
      elasc(1,1) = (s1 - s2)/(inf_str * 2.0d0)
      elasc(1,2) = (s3 - s4)/(inf_str * 2.0d0)
      elasc(1,3) = (s5 - s6)/(inf_str * 2.0d0)
      elasc(2,1) = elasc(1,2)
      elasc(3,1) = elasc(1,3)

!!!  C_22,C_23
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(2,2)=inf_str
      call strain
      call potential
      call calcstresstensor
      s1=sgmmat(2,2); s3=sgmmat(3,3)
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(2,2)=-inf_str
      call strain
      call potential
      call calcstresstensor
      s2=sgmmat(2,2); s4=sgmmat(3,3)
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;

!      c22 = (s1 - s2)/(inf_str * 2.0d0)
!      c23 = (s3 - s4)/(inf_str * 2.0d0)
      elasc(2,2) = (s1 - s2)/(inf_str * 2.0d0)
      elasc(2,3) = (s3 - s4)/(inf_str * 2.0d0)
      elasc(3,2) = elasc(2,3)

!!!  C_33
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(3,3)=inf_str
      call strain
      call potential
      call calcstresstensor
      s1=sgmmat(3,3)
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(3,3)=-inf_str
      call strain
      call potential
      call calcstresstensor
      s2=sgmmat(3,3)
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;

!      c33 = (s1 - s2)/(inf_str * 2.0d0)
      elasc(3,3) = (s1 - s2)/(inf_str * 2.0d0)

!!!  C_44
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(1,2) = inf_str/2.0d0
      strmat_set(2,1) = strmat_set(1,2)
      call strain
      call potential
      call calcstresstensor
      s1=sgmmat(1,2)
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(1,2) = -inf_str/2.0d0
      strmat_set(2,1) = strmat_set(1,2)
      call strain
      call potential
      call calcstresstensor
      s2=sgmmat(1,2)
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;

!      c44 = (s1 - s2)/(inf_str * 2.0d0)
      elasc(4,4) = (s1 - s2)/(inf_str * 2.0d0)

!!!  C_55
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(2,3) = inf_str/2.0d0
      strmat_set(3,2) = strmat_set(2,3)
      call strain
      call potential
      call calcstresstensor
      s1=sgmmat(2,3)
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(2,3) = -inf_str/2.0d0
      strmat_set(3,2) = strmat_set(2,3)
      call strain
      call potential
      call calcstresstensor
      s2=sgmmat(2,3)
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;

!      c55 = (s1 - s2)/(inf_str * 2.0d0)
      elasc(5,5) = (s1 - s2)/(inf_str * 2.0d0)

!!!  C_66
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(3,1) = inf_str/2.0d0
      strmat_set(1,3) = strmat_set(3,1)
      call strain
      call potential
      call calcstresstensor
      s1=sgmmat(3,1)
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set=0.0d0
      strmat_set(3,1) = -inf_str/2.0d0
      strmat_set(1,3) = strmat_set(3,1)
      call strain
      call potential
      call calcstresstensor
      s2=sgmmat(3,1)
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;

!      c66 = (s1 - s2)/(inf_str * 2.0d0)
      elasc(6,6) = (s1 - s2)/(inf_str * 2.0d0)

!      write (6,'("# Elastic constants (numerical evaluation)")')
!      write (6,'("# Using delta_e = ",3e14.4)') inf_str
!      write (6,'("# Results not guaranteed")')
!      write (6,'(6f10.4)') elasc(1,1)/gpa,elasc(1,2)/gpa,elasc(1,3)/gpa,0.,0.,0.
!      write (6,'(6f10.4)') elasc(1,2)/gpa,elasc(2,2)/gpa,elasc(2,3)/gpa,0.,0.,0.
!      write (6,'(6f10.4)') elasc(1,3)/gpa,elasc(2,3)/gpa,elasc(3,3)/gpa,0.,0.,0.
!      write (6,'(6f10.4)') 0.,0.,0.,elasc(4,4)/gpa,0.,0.
!      write (6,'(6f10.4)') 0.,0.,0.,0.,elasc(5,5)/gpa,0.
!      write (6,'(6f10.4)') 0.,0.,0.,0.,0.,elasc(6,6)/gpa

      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store;
      strmat_set = strmat_store
      deallocate (rx_store,ry_store,rz_store)

      end
      
      
