!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     SUBROUTINE READCONDITION
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine readcondition
      use variables
      use constants
      use bookkeep_param
      use rp_param

!       subroutines contained:
!        readsetint(word,nwlen,nvalue,nstat)
!        read integral value
!
!        readsetlog(word,nwlen,nvalue,nstat)
!        read logical value
!
!        readsetdp(word,nwlen,nvalue,nstat)
!        read double precision value
!
!        readsetchar(word,nwlen,nvalue,nstat)
!        read character value
!

      call readsetdp('rc',2,rc,nstat)
      call readsetdp('dt',2,dt,nstat)

      call readsetint('nbook',5,nbook,nstat)
      call readsetdp('frc',3,frc,nstat)
      call readsetint('nbk',3,nbk,nstat)
      call readsetlog('rpart',5,rpart,nstat)
      call readsetint('npcx',4,npcx,nstat)
      call readsetint('npcy',4,npcy,nstat)
      call readsetint('npcz',4,npcz,nstat)

      call readsetint('multicellx',10,multicellx,nstat)
      call readsetint('multicelly',10,multicelly,nstat)
      call readsetint('multicellz',10,multicellz,nstat)

      call readsetint('naccew',6,naccew,nstat)

      call readsetint('step_ite',7,step_ite,nstat)
      call readsetint('vscale',6,vscale,nstat)
      call readsetint('damper',6,damper,nstat)
      call readsetint('dump_frequency',14,dump_frequency,nstat)
      if ((dump_frequency>0).and.(step_ite/dump_frequency)>1000) then
         print *,'You are going to create too many conf-XXX.cfg files..'
         print *,'I change dump_frequency to ',step_ite/1000
         dump_frequency=step_ite/1000
      endif
      call readsetint('meam_stress_frequency',21,meam_stress_frequency,nstat)
      call readsetlog('cellconstx',10,cellconstx,nstat)
      call readsetlog('cellconsty',10,cellconsty,nstat)
      call readsetlog('cellconstz',10,cellconstz,nstat)
      call readsetint('algorithm',9,algorithm,nstat)
      call readsetdp('relax_factor',12,relax_factor,nstat)

      call readsetlog('pbcx',4,pbcx,nstat)
      call readsetlog('pbcy',4,pbcy,nstat)
      call readsetlog('pbcz',4,pbcz,nstat)

!      call readsetlog('mulx',4,mulx,nstat)
!      call readsetlog('muly',4,muly,nstat)
!      call readsetlog('mulz',4,mulz,nstat)

      call readsetdp('temp_set',8,temp_set,nstat)
      call readsetdp('temp_weight',11,temp_weight,nstat)
      call readsetdp('sgm_set',7,sgm_set,nstat)
      call readsetdp('sxx',3,sxx,nstat)
      call readsetdp('syy',3,syy,nstat)
      call readsetdp('szz',3,szz,nstat)
      call readsetdp('syz',3,syz,nstat)
      call readsetdp('szx',3,szx,nstat)
      call readsetdp('sxy',3,sxy,nstat)
      call readsetlog('dstress',7,dstress,nstat)
      call readsetint('dstress_start',13,dstress_start,nstat)
      call readsetdp('dsxx',4,dsxx,nstat)
      call readsetdp('dsyy',4,dsyy,nstat)
      call readsetdp('dszz',4,dszz,nstat)
      call readsetdp('dsyz',4,dsyz,nstat)
      call readsetdp('dszx',4,dszx,nstat)
      call readsetdp('dsxy',4,dsxy,nstat)
      call readsetdp('stress_weight',13,stress_weight,nstat)
      call readsetint('average_span',12,average_span,nstat)
      if (average_span>average_span_max) average_span=average_span_max
      if (average_span<average_span_min) average_span=average_span_min
      allocate (sgmmat_prv(3,3,average_span)); sgmmat_prv=0.0d0
      call readsetdp('prdamper',8,prdamper,nstat)
      if (prdamper < 0.0) prdamper = 0.0
      call readsetdp('prlimit',7,prlimit,nstat)
      call readsetlog('fixrotation',11,fixrotation,nstat)

      call readsetlog('continue_md',11,continue_md,nstat)
      call readsetlog('ini_velocity',12,ini_velocity,nstat)
      call readsetint('ran_seed',8,ran_seed,nstat)

      call readsetdp('econstd',7,econstd,nstat)

      call readsetdp('tolene',6,tolene,nstat)
      call readsetdp('tolfor',6,tolfor,nstat)
      call readsetdp('tolst',5,tolst,nstat)

      call readsetlog('inst',4,inst,nstat)
      call readsetint('inst_drawvector_maxmode',23,inst_drawvector_maxmode,nstat)
      call readsetint('inst_curve_maxmode',18,inst_curve_maxmode,nstat)
      call readsetlog('inst_curve',10,inst_curve,nstat)
      call readsetdp('inst_curve_range',16,inst_curve_range,nstat)
      call readsetint('inst_curve_mesh',15,inst_curve_mesh,nstat)
      call readsetlog('inst_decom',10,inst_decom,nstat)
      call readsetint('inst_decom_nfile',16,inst_decom_nfile,nstat)
      call readsetlog('inst_decom_curve',16,inst_decom_curve,nstat)
      call readsetint('inst_decom_maxmode',18,inst_decom_maxmode,nstat)
      call readsetlog('inst_surf',9,inst_surf,nstat)
      call readsetint('inst_surf_x',11,inst_surf_x,nstat)
      call readsetint('inst_surf_y',11,inst_surf_y,nstat)
      call readsetdp('inst_surf_xmn',13,inst_surf_xmn,nstat)
      call readsetdp('inst_surf_xmx',13,inst_surf_xmx,nstat)
      call readsetdp('inst_surf_ymn',13,inst_surf_ymn,nstat)
      call readsetdp('inst_surf_ymx',13,inst_surf_ymx,nstat)
      call readsetdp('inst_surf_gridx',15,inst_surf_gridx,nstat)
      call readsetdp('inst_surf_gridy',15,inst_surf_gridy,nstat)
      call readsetdp('voronoi',7,rc_vor,nstat)
      rc_vor = rc_vor * ang

      call readsetlog('neb',3,neb,nstat)
      call readsetint('neb_num',7,neb_num,nstat)
      call readsetint('neb_ite',7,neb_ite,nstat)
      call readsetdp('neb_tol',7,neb_tol,nstat)
      call readsetdp('neb_dt',6,neb_dt,nstat)

      call readsetlog('diffusion',9,diffusion,nstat)
      call readsetint('difout_int',10,difout_int,nstat)
      if ((diffusion).and.(step_ite/difout_int>999)) stop 'Please set larger difout_int'

      call readsetint('appl_temp_step',14,appl_temp_step,nstat)
      call readsetint('appl_temp_length',16,appl_temp_length,nstat)
      call readsetdp('appl_temp_temp1',15,appl_temp_temp1,nstat)
      call readsetdp('appl_temp_temp2',15,appl_temp_temp2,nstat)

      call readsetdp('potparam1',9,potparam1,nstat)
      call readsetdp('potparam2',9,potparam2,nstat)
      call readsetdp('potparam3',9,potparam3,nstat)
      call readsetdp('potparam4',9,potparam4,nstat)

      end

!CCCCCCCCCCCCCCC SUBROUTINES CCCCCCCCCCCCCCCCCCCCCC
!CCC   Extract kerword from SETDAT (integer)
      subroutine readsetint(word,nwlen,nvalue,nstat)
      integer :: nwlen
      character (nwlen) :: word
      character (nwlen) :: ichar
      integer :: nvalue,ivalue
      
      open (20,file='SETDAT',status='OLD',action='read')
 10   read (20,*,end=100) ichar !trial read
      if (ichar(:1)=='#') then
         go to 10               !skip a line if it is a comment line
      else
         backspace 20           !read again if it is not a comment line
      endif
      read (20,*,end=100,err=10) ichar, ivalue
      if (ichar(:nwlen)==word(:nwlen)) then
         nvalue=ivalue
         nstat=1
         go to 200
      endif
      go to 10
 100  nstat=0
 200  continue
      close (20)
      end

!CCC   Extract kerword from SETDAT (logical)
      subroutine readsetlog(word,nwlen,nvalue,nstat)
      integer :: nwlen
      character (nwlen) :: word
      character (nwlen) :: ichar
      logical :: nvalue,ivalue
      character (5) :: jvalue

      open (20,file='SETDAT',status='OLD',action='read')
 10   read (20,*,end=100) ichar !trial read
      if (ichar(:1)=='#') then
         go to 10               !skip a line if it is a comment line
      else
         backspace 20           !read again if it is not a comment line
      endif
      read (20,*,end=100,err=20) ichar, ivalue
      if (ichar(:nwlen)==word(:nwlen)) then
         nvalue=ivalue
         nstat=1
         go to 200
      endif
      go to 10
 20   backspace 20
      read (20,*,end=100) ichar, jvalue
      if (ichar(:nwlen)==word(:nwlen)) then
         if ((jvalue(:3)=='yes').or.(jvalue(:3)=='Yes').or. &
         (jvalue(:3)=='YES')) then
            nvalue=.true.
            nstat=1
         else
            nvalue=.false.
            nstat=1
         endif
         go to 200
      endif
      go to 10
 100  nstat=0
 200  continue
      close (20)
      end

!CCC   Extract kerword from SETDAT (double precision)
      subroutine readsetdp(word,nwlen,nvalue,nstat)
      integer :: nwlen
      character (nwlen) :: word
      character (nwlen) :: ichar
      double precision :: nvalue,ivalue
      
      open (20,file='SETDAT',status='OLD',action='read')
 10   read (20,*,end=100) ichar !trial read
      if (ichar(:1)=='#') then
         go to 10               !skip a line if it is a comment line
      else
         backspace 20           !read again if it is not a comment line
      endif
      read (20,*,end=100,err=10) ichar, ivalue
      if (ichar(:nwlen)==word(:nwlen)) then
         nvalue=ivalue
         nstat=1
         go to 200
      endif
      go to 10
 100  nstat=0
 200  continue
      close (20)
      end

!CCC   Extract kerword from SETDAT (character)
      subroutine readsetchar(word,nwlen,nvalue,nstat)
      integer :: nwlen
      character (nwlen) :: word
      character (nwlen) :: ichar
      character (nwlen) :: nvalue,ivalue
      
      open (20,file='SETDAT',status='OLD',action='read')
 10   read (20,*,end=100) ichar !trial read
      if (ichar(:1)=='#') then
         go to 10               !skip a line if it is a comment line
      else
         backspace 20           !read again if it is not a comment line
      endif
      read (20,*,end=100,err=10) ichar, ivalue
      if (ichar(:nwlen)==word(:nwlen)) then
         nvalue=ivalue
         nstat=1
         go to 200
      endif
      go to 10
 100  nstat=0
 200  continue
      close (20)
      end

